# 动手学深度学习

```eval_rst

.. only:: html

   这是一个深度学习的教学项目。我们将使用 `Apache MXNet (incubating) <https://github.com/apache/incubator-mxnet>`_ 的最新 Gluon 接口来演示如何从零开始实现深度学习的各个算法。我们的将利用 `Jupyter notebook <http://jupyter.org/>`_ 能将文档、代码、公式和图形统一在一起的优势，提供一个交互式的学习体验。这个项目可以作为一本书、上课用的材料、现场演示的案例和一个可以尽情拷贝的代码库。据我们所知，目前并没有哪个项目能既覆盖全面深度学习，又提供交互式的可执行代码。我们将尝试弥补这个空白。

   - `第一季十九课视频汇总 <https://discuss.gluon.ai/t/topic/753>`_ （本教程在不断改进中。最接近视频中的版本是 `v0.6.1 <https://github.com/mli/gluon-tutorials-zh/releases/tag/v0.61>`_）。

   - 可打印的 `PDF 版本在这里 <./gluon_tutorials_zh.pdf>`_。

   - 课程源代码在 `Github <https://github.com/mli/gluon-tutorials-zh>`_ （亲，给个好评加颗星）。

   - 请使用 `http://discuss.gluon.ai/ <http://discuss.gluon.ai/>`_ 来进行讨论（每个章节最后也有对应的讨论链接）。


   目录
   ----

.. toctree::
   :maxdepth: 2

   chapter_introduction/index
   chapter_prerequisite/index
   chapter_deep-learning-basics/index
   chapter_deep-learning-computation/index
   chapter_convolutional-neural-networks/index
   chapter_recurrent-neural-networks/index
   chapter_optimization/index
   chapter_computational-performance/index
   chapter_computer-vision/index
   chapter_natural-language-processing/index
   chapter_appendix/index

```
